//% color="#696969" iconWidth=38 iconHeight=28
namespace Ark{
    //% block="I2C获取颜色" blockType="reporter"
    export function get_all_color(parameter: any,block:any){
        Generator.addImport("from mpython import *");
        Generator.addImport("from nplus import *");
        Generator.addInitHeader(`color`,`color=Color()`);
        Generator.addInitTail(`color`, `color.setup()\ncolor.turn_on()`);

        Generator.addCode(`color.getRGB()`);

    }

    //% block="I2C获取[RGB]" blockType="reporter"
    //% RGB.shadow="dropdown" RGB.options="RGB"
    export function get_color(parameter:any, block:any){
        let rgb = parameter.RGB.code;
        Generator.addImport("from mpython import *");
        Generator.addImport("from nplus import *");
        Generator.addInitHeader(`color`, `color=Color()`);
        Generator.addInitTail(`color`, `color.setup()\ncolor.turn_on()`);
        Generator.addCode(`color.getRGB()[${rgb}]`);
    }

    //% block="I2C获取HSV" blockType="reporter"
    export function get_all_color_hsv(parameter: any, block: any) {
        Generator.addImport("from mpython import *");
        Generator.addImport("from nplus import *");
        Generator.addInitHeader(`color`, `color=Color()`);
        Generator.addInitTail(`color`, `color.setup()\ncolor.turn_on()`);
        Generator.addCode(`color.getHSV()`);
    }

    //% block="I2C获取HSV[HSV]" blockType="reporter"
    //% HSV.shadow="dropdown" HSV.options="HSV"
    export function get_hsv(parameter: any, block: any) {
        let hsv = parameter.HSV.code;
        Generator.addImport("from mpython import *");
        Generator.addImport("from nplus import *");
        Generator.addInitHeader(`color`, `color=Color()`);
        Generator.addInitTail(`color`, `color.setup()\ncolor.turn_on()`);
        Generator.addCode(`color.getHSV()[${hsv}]`);
    }

    //% block="I2C识别[COLOR]" blockType="boolean"
    //% COLOR.shadow="dropdown" COLOR.options="COLOR"
    export function discern_color(parameter: any, block: any) {
        let color = parameter.COLOR.code;
        Generator.addImport("from mpython import *");
        Generator.addImport("from nplus import *");
        Generator.addInitHeader(`color`, `color=Color()`);
        Generator.addInitTail(`color`, `color.setup()\ncolor.turn_on()`);
        Generator.addCode(`color.discern_${color}()`);
    }

    //% block="I2C超声波" blockType="reporter"
    export function ultrasonic(parameter: any, block: any) {
        Generator.addImport("from mpython import *");
        Generator.addImport("from nplus import *");
        Generator.addInit(`ultrasonic`, `ultrasonic = Ultrasonic()`);
        Generator.addCode(`ultrasonic.distance()`);
    }

    //% block="颜色传感器设置白平衡R[R]G[G]B[B]" blockType="command"
    //% R.shadow="number" R.defl="1"
    //% G.shadow="number" G.defl="1"
    //% B.shadow="number" B.defl="1"
    export function setbw_rgb(parameter: any, block: any) {
        let r = parameter.R.code;
        let g = parameter.G.code;
        let b = parameter.B.code;
        Generator.addImport("from mpython import *");
        Generator.addImport("from nplus import *");
        Generator.addInit(`line`, `line=Line()`);
        Generator.addCode(`line.setbw_rgb(${r}, ${g}, ${b})`);
    }

    //% block="循迹传感器设置阈值[THRESHOLD]" blockType="command"
    //% THRESHOLD.shadow="number" THRESHOLD.defl="100"
    export function set_line_threshold(parameter: any, block: any) {
        let threshold = parameter.THRESHOLD.code;
        Generator.addImport("from mpython import *");
        Generator.addImport("from nplus import *");
        Generator.addInit(`line`, `line=Line()`);
        Generator.addCode(`line.set_line_threshold(${threshold})`);
    }

    //% block="I2C循迹获取[LINE_N]循线值" blockType="reporter"
    //% LINE_N.shadow="dropdown" LINE_N.options="LINE_N"
    export function read_sensor(parameter: any, block: any) {
        let line_n = parameter.LINE_N.code;
        Generator.addImport("from mpython import *");
        Generator.addImport("from nplus import *");
        Generator.addInit(`line`, `line=Line()`);
        Generator.addCode(`line.read_sensor(${line_n})`);
    }

    //% block="I2C循迹[LINE_N]碰到黑线" blockType="boolean"
    //% LINE_N.shadow="dropdown" LINE_N.options="LINE_N"
    export function touch_sensor(parameter: any, block: any) {
        let line_n = parameter.LINE_N.code;
        Generator.addImport("from mpython import *");
        Generator.addImport("from nplus import *");
        Generator.addInit(`line`, `line=Line()`);
        Generator.addCode(`line.touch_line()`);
    }

    //% block="I2C电机[MOTOR][STATUS]速度[SPEED]" blockType="command"
    //% MOTOR.shadow="dropdown" MOTOR.options="MOTOR"
    //% STATUS.shadow="dropdown" STATUS.options="STATUS"
    //% SPEED.shadow="range"  SPEED.params.min=0 SPEED.params.max=100 SPEED.defl=0
    export function set_motor(parameter: any, block: any) {
        let status = parameter.STATUS.code;
        let motor = parameter.MOTOR.code;
        let speed = parameter.SPEED.code;
        Generator.addImport("from mpython import *");
        Generator.addImport("from nplus import *");
        Generator.addInit(`motor`, `motor=Motor()`);
        if(status == "0")
            Generator.addCode(`motor.${motor}(${speed})`);
        else
            Generator.addCode(`motor.${motor}(-${speed})`);
    }

    //% block="MPU6050获取[XYZ]加速度" blockType="reporter"
    //% XYZ.shadow="dropdown" XYZ.options="XYZ"
    export function Get_Accel(parameter: any, block: any) {
        let xyz = parameter.XYZ.code;
        Generator.addImport("from mpython import *");
        Generator.addImport("from nplus import *");
        Generator.addInit(`mpu`, `mpu=MPU6050()\nmpu.MPU_Init()`);
        Generator.addCode(`mpu.Get_Accel_${xyz}()`);
    }

    //% block="MPU6050获取[XYZ]角速度" blockType="reporter"
    //% XYZ.shadow="dropdown" XYZ.options="XYZ"
    export function Get_Gyro(parameter: any, block: any) {
        let xyz = parameter.XYZ.code;
        Generator.addImport("from mpython import *");
        Generator.addImport("from nplus import *");
        Generator.addInit(`mpu`, `mpu=MPU6050()\nmpu.MPU_Init()`);
        Generator.addCode(`mpu.Get_Gyro_${xyz}()`);
    }

    //% block="获取[SHT]" blockType="reporter"
    //% SHT.shadow="dropdown" SHT.options="SHT"
    export function sht20(parameter: any, block: any) {
        let sht = parameter.SHT.code;
        Generator.addImport("from mpython import *");
        Generator.addImport("from nplus import *");
        Generator.addInit(`sht`, `sht=SHT20()`);
        Generator.addCode(`sht.${sht}()`);
    }

}
    
